<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>Kris temp clip board</title>
<script type="text/javascript" src="lib/jquery-3.6.1.min.js"></script>
<script>
	$(function(){
		console.log("load complete!")
		$(".autosize-textarea").on('input', function(event) {
			var val = $(event.target).val();
			var index = $(event.target).data('index');
			var postData = {
				"index": index,
				"text": val
			}
			$('#' + $(event.target).data('id')).text(val);
			$.ajax({
				url: "updateText",
				type: "post",
				data: postData,
				processData: false,
				contentType: false,
				success: function(data){
					console.log(data);
					window.location.reload();
				},
				error: function(e){
					console.log(e);
				}
			});
			console.log(index);
		})
		
	});
	
	function preUpload(){
		var files = $("#files")[0];
		$("#preview").text(Array.from(files.files).map(file => file.name).join(',') + "(共" + files.files.length + "个文件)");
		$("#submit").css({"display":"block"})
	}
	
	function upload(){
		var form = new FormData($("#upload")[0]);
		$.ajax({
			url: "upload",
			type: "post",
			data: form,
			processData: false,
			contentType: false,
			success: function(data){
				console.log(data);
				window.location.reload();
			},
			error: function(e){
				console.log(e);
			}
		});
	}
	
	function remove(file){
		var msg = "remove " + file + " ?";
		if (confirm(msg) == true) {
			$.ajax({
				url: "remove?file=" + file,
				type: "get",
				data: file,
				processData: false,
				contentType: false,
				success: function(data){
					console.log(data);
					window.location.reload();
				},
				error: function(e){
					console.log(e);
				}
			});
		}
	}
</script>
<style type="text/css">
	.remove {
		color: white;
	}
	.remove: hover {
		color: cadetblue;
		cursor: pointer;
	}
	.file {
		color: 0000ee;
		cursor:pointer; 
	}
	.file: hover {
		color: cadetblue;
	}
	.autosize-textarea {
		position: relative;
		display: inline-block;
		vertical-align: middle;
		min-height: 30px;
	}
	.autosize-textarea .hidden-box {
		position: relative;
		visibility: hidden;
		min-width: 100px;
		/* min-height: 30px; */
    	word-break: break-all;
		padding: 4px 8px;
		font-family: monospace;
		font-size: 14px;
		line-height: 20px;
		white-space: pre-wrap;
		border: 1px solid #CCCCCC;
		box-sizing: border-box;
	}
	.autosize-textarea textarea {
		position: absolute;
		top: 0;
		left: 0;
		width: 100%;
		height: 100%;
		padding: 4px 8px;
		box-sizing: border-box;
		resize: none;
		font-size: 14px;
		line-height: 20px;
    	word-break: break-all;
    	border-radius: 4px;
    	border-color: #dddbd2;
		overflow: hidden;
	}
	.autosize-textarea textarea:focus-visible {
		outline: none;
	}
	
	.m8 {
		margin: 8px;
	}
</style>
</head>
<body style="padding:8px;margin:0;height:100vh;box-sizing:border-box">
	<div style="display:flex;border:6px cadetblue dashed;border-radius:10px;max-height:100%;box-sizing:border-box;">
		<div style="width:50%;max-height:100%;overflow-y:auto;">
			<ul>
				<c:forEach items="${notes}" var="note" varStatus="s">
					<li class="m8">
						<div class="autosize-textarea">
							<div id="autosize-textarea-hidden-box-${s.index}"  class="hidden-box">${note}</div>
							<textarea data-index="${s.index}" data-id="autosize-textarea-hidden-box-${s.index}" style="background-color: cornsilk;">${note}</textarea>	
						</div>
					</li>
				</c:forEach>
				<li class="m8" style="color:cadetblue">add</li>
			</ul>
		</div>
		<div style="width:50%;max-height:100%;overflow-y:auto;">
			<ul>
				<c:forEach items="${files}" var="file">
					<li class="m8"><a class="file" href="download?file=${file}">${file}</a>&nbsp;&nbsp;&nbsp;<span class="remove" onclick="remove('${file}')">remove</span></li>
				</c:forEach>
				<li class="m8" style="color:cadetblue;">
					<span onclick="$('#files').click();" style="cursor:pointer">upload</span>
					<span id="preview"></span><br/>
					<span style="cursor:pointer;color:cadetblue;display:none" id="submit" onclick="upload()">submit</span>
				</li>
			</ul>
		</div>
		<form id="upload">
			<input id="files" name="files" type="file" style="display:none" onchange="preUpload()" multiple="multiple"/><br/>
		</form>
	</div>
</body>
</html>